/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 2 "rcfile.y"
/*-
 * Copyright (c) 2001 Jordan DeLong
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of contributors may be
 *    used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#include "wm.h"
#include "rclex.h"

/* set a string option after freeing the old one */
#define SETSTR(opt, val) do {	\
	if ((opt)) free((opt));	\
	(opt) = (val);		\
} while (0)

/* used for the dgroup_t that decor are being added to */
static dgroup_t	*dgroup_current	= NULL;

/* used to build subparams */
#define			SUBP_STACK_GRAN		10
static int		subparams_stack_loc	= 0;
static int		subparams_stack_size	= 0;
static subparams_t	**subparams_stack	= NULL;

/* table for plugin names mapped to forplug files */
typedef struct forplug {
	char	*plugin;	/* name of the plugin */
	char	*incfile;	/* path to conditionaly parsed file */

	SLIST_ENTRY(forplug) fp_list;
} forplug_t;
static SLIST_HEAD(, forplug) forplug_tab = SLIST_HEAD_INITIALIZER(forplug_tab);

/* yacc error reporting */
static int yyerror(char *s) {
	warnx("%s, %d: %s", filename, yylineno, s);
	return 0;
}

/* add a param; for the plugin parameter parsing */
static int rcfile_addparam(char *name, char *value, subparams_t *subparams) {
	param_t *param;

	/* make the paramater, name->value pair */
	param = plugin_param(name, value);
	if (!param)
		goto failure;

	/* initialize subparams for the new parameter */
	param->subparams.count = subparams ? subparams->count : 0;
	param->subparams.params = subparams ? subparams->params : NULL;
	if (subparams)
		free(subparams);

	/* add the new parameter onto the current subparam */
	if (plugin_subparams_add(subparams_stack[subparams_stack_loc - 1],
			param) != 0)
		goto failure;

	return 0;

failure:
	if (!param) {
		free(name);
		free(value);
	} else
		plugin_param_free(param);
	yyerror("couldn't add plugin parameter");

	return -1;
}

/* add a plugin -> filename to the forplug table */
static forplug_t *rcfile_forplug(char *plugin, char *incfile) {
	forplug_t *fp_tab;

	/* add an entry to the table */
	fp_tab = malloc(sizeof(forplug_t));
	if (!fp_tab)
		return NULL;
	fp_tab->plugin = plugin;
	fp_tab->incfile = incfile;
	SLIST_INSERT_HEAD(&forplug_tab, fp_tab, fp_list);

	return fp_tab;
}

/* find a forplug entry for a plugin */
static forplug_t *rcfile_find_forplug(char *plugin) {
	forplug_t *fp_tab;

	SLIST_FOREACH(fp_tab, &forplug_tab, fp_list)
		if (strcmp(plugin, fp_tab->plugin) == 0)
			break;

	return fp_tab;
}

/* make a filename using filedir for relative paths */
static char *rcfile_filename(char *name) {
	if (name[0] != '/') {
		char *tmp = malloc(strlen(name) + strlen(filedir) + 1);
		if (!tmp)
			return NULL;
		snprintf(tmp, strlen(name) + strlen(filedir) + 1,
			"%s%s", filedir, name);
		return tmp;
	} else
		return strdup(name);
}

#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 136 "rcfile.y"
typedef union {
	double		flnum;		/* floating point values */
	int		num;		/* numeric values */
	char		*str;		/* string values */
	void		*vptr;		/* some void * */
	subparams_t	*subparams;	/* subparameters for a plugin */
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 172 "y.tab.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define OPTIONS 257
#define KEYS 258
#define PIXMAPS 259
#define DECOR 260
#define STYLE 261
#define PLUGDAT 262
#define FORPLUG 263
#define OPAQUEMOVE 264
#define MOUSEMOD 265
#define ANIMDELAY 266
#define DESKTOPCNT 267
#define DESKTOPWID 268
#define DESKTOPHEI 269
#define FULLSCRZOOM 270
#define LINEWIDTH 271
#define LINEFG 272
#define WANTMITSHM 273
#define WSPACESLIDE 274
#define RELRESIZE 275
#define FOCUSNEW 276
#define XINCORRECT 277
#define FOCUS 278
#define FOCUSTYPE 279
#define PLACEMENT 280
#define PLACETYPE 281
#define PLACENONZEROS 282
#define PLACETRANS 283
#define TITLEFONT 284
#define TITLE 285
#define TITLECOLOR 286
#define KEYNAME 287
#define PLACEINTERACT 288
#define INTERACTTIME 289
#define DBUTTONLINES 290
#define DECTYPE 291
#define DECEDGE 292
#define ACTION 293
#define GROUPS 294
#define DEFAULT 295
#define TRANSIENT 296
#define INTERNAL 297
#define LOAD 298
#define PARAM 299
#define FPARAM 300
#define PLUGPARAM 301
#define INTEGER 302
#define BOOLVAL 303
#define MODIFIER 304
#define NOMASK 305
#define CYCLETYPE 306
#define MVDIR 307
#define STRING 308
#define IDENT 309
#define FLOAT 310
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,    0,    0,    0,   13,    0,   14,    0,
   10,   10,   11,   11,   12,   12,   12,   12,   18,   18,
   19,   19,   19,   21,   21,    9,   25,    9,   24,   24,
   24,   15,   15,   15,   15,   15,   15,   15,   15,   15,
   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
   15,   15,   16,   16,   17,   17,   17,   20,   20,   23,
   23,   23,   23,   23,   22,   22,    7,    8,    8,    1,
    1,    2,    2,    3,    3,    3,    3,    3,    3,    4,
    4,   26,   27,   27,   27,    6,    5,
};
static const YYINT yylen[] = {                            2,
    0,    2,    5,    5,    5,    5,    0,    5,    0,    4,
    0,    3,    0,    3,    0,    3,    5,    5,    0,    3,
    0,    5,    3,    0,    3,    1,    0,    4,    0,    5,
    5,    1,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    1,    4,    1,    2,    2,    1,    2,    1,
    2,    2,    2,    2,    1,   16,    1,    1,    1,    3,
    3,    1,    3,    0,    1,    1,    1,    1,    3,    0,
    1,    1,    0,    2,    8,    1,    1,
};
static const YYINT yydefred[] = {                         1,
    0,    2,    0,    0,    0,    9,    0,    7,   11,   13,
   15,    0,    0,    0,    0,    0,    0,   27,   26,   10,
   67,    0,    0,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    3,    0,   53,    0,    4,    0,
   55,    0,    0,    0,    0,    5,    0,   29,    6,    8,
   38,    0,   40,   41,   33,   34,   35,   37,   47,   48,
   49,   50,   51,   39,   52,   36,   46,   43,   42,   44,
   45,   12,    0,   14,   19,   21,   56,   57,   16,    0,
   72,    0,    0,    0,    0,    0,    0,    0,   28,   71,
   70,    0,    0,   78,   77,   75,   54,   58,    0,   17,
    0,   65,    0,    0,   18,    0,    0,    0,   73,    0,
   59,   20,   24,    0,   23,    0,    0,   79,    0,    0,
   31,   30,   60,    0,    0,    0,   82,   22,    0,   83,
    0,   86,   62,   63,   64,   25,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   85,    0,    0,   87,    0,    0,   66,   81,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  312,  256,  257,  258,  261,  262,  263,  298,  123,  123,
  123,  326,  308,  325,  322,  323,  324,  123,   59,  321,
  308,  319,  308,  256,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  280,
  282,  283,  288,  289,  125,  327,  256,  287,  125,  328,
  256,  259,  260,  284,  286,  125,  329,  337,   59,  321,
  303,   40,  313,  302,  302,  302,  302,  303,  302,  308,
  303,  303,  303,  303,  303,  279,  281,  303,  303,  303,
  302,   59,  308,   59,  123,  123,  308,  308,   59,  336,
  304,  305,  314,  313,  330,  331,  299,  300,  125,   41,
   41,  124,  302,  306,  307,  308,  315,  256,  309,  125,
  332,  256,  294,  309,  125,  334,  308,  308,  304,   44,
  319,   59,  123,  291,   59,  308,  319,  302,  333,  292,
  321,  321,  256,  295,  296,  297,  309,  125,  335,  338,
  302,  309,  318,  318,  318,   59,  339,  302,  309,  302,
   58,  302,  310,  320,  285,  320,   58,  303,  302,  303,
   58,  293,  302,  293,  293,  309,  317,  317,  316,  317,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          1,
   63,   93,  107,  169,  167,  143,   22,  154,   20,   15,
   16,   17,   14,   12,   46,   50,   57,   95,   96,  111,
  129,  116,  139,   90,   58,  140,  147,
};
static const YYINT yysindex[] = {                         0,
 -246,    0, -101,  -91,  -90,    0, -274,    0,    0,    0,
    0,  -50, -273, -272, -121, -118,  -96,    0,    0,    0,
    0,  -22,  -50,    0, -265,   -1, -262, -261, -260, -259,
 -258, -256, -264, -255, -254, -253, -252, -250, -232, -227,
 -248, -247, -245, -243,    0,   -2,    0, -244,    0,    1,
    0,  -62,  -61, -242, -241,    0,    4,    0,    0,    0,
    0, -286,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   -1,    0,    0,    0,    0,    0,    0, -122,
    0,   24,  -33, -282, -123, -120, -240, -239,    0,    0,
    0, -234,   27,    0,    0,    0,    0,    0, -273,    0,
   13,    0,  -49, -216,    0,   17, -231, -273,    0, -224,
    0,    0,    0, -213,    0,  -50,  -50,    0, -124, -222,
    0,    0,    0, -228, -228, -228,    0,    0,   23,    0,
 -219,    0,    0,    0,    0,    0, -225, -217,   28, -289,
 -198,    0,    0, -289,   30, -214, -212, -211,   35, -199,
 -207, -197,    0, -196, -210,    0, -210, -210,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   39,    0,    0,    0,    0,    0,    0,
    0,    0,   41,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   42,    0,  -59,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   43,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
   20,    0,    0,    0, -140, -105,  -95,  -48,  -17,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 250
static const YYINT yytable[] = {                         84,
  138,  110,   99,   45,  115,   60,   49,  101,   19,    2,
    3,    4,  152,  121,    5,    6,    7,   91,   92,  103,
  153,    9,  127,  104,  105,  106,  168,  170,   56,  144,
  145,   10,   11,   13,   21,   23,   59,   61,   62,   64,
   65,   66,   67,   70,   68,   69,   76,   71,   72,   73,
   74,    8,   75,   77,   78,   79,   82,   80,   81,   84,
   85,   86,   89,   83,  100,   87,   88,  117,  118,  119,
  120,  122,   18,  123,  124,  125,  126,  128,  130,  141,
  142,  146,  148,  149,  150,  151,  155,  157,  158,  159,
  102,  160,  161,  162,  163,  164,  165,   74,  166,   76,
   61,   80,   94,    0,    0,  156,    0,    0,  131,  132,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  133,  108,    0,   24,  112,    0,   47,    0,    0,
    0,    0,   25,   26,   27,   28,   29,   30,   31,   32,
   33,   34,   35,   36,   37,   38,   39,    0,   40,   51,
   41,   42,   52,   53,    0,    0,   43,   44,   48,    0,
  134,  135,  136,  113,    0,    0,   97,   98,    0,    0,
    0,    0,    0,    0,  137,  109,    0,   54,  114,   55,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   84,
};
static const YYINT yycheck[] = {                         59,
  125,  125,  125,  125,  125,   23,  125,   41,   59,  256,
  257,  258,  302,  109,  261,  262,  263,  304,  305,  302,
  310,  123,  118,  306,  307,  308,  167,  168,  125,  135,
  136,  123,  123,  308,  308,  308,   59,  303,   40,  302,
  302,  302,  302,  308,  303,  302,  279,  303,  303,  303,
  303,  298,  303,  281,  303,  303,   59,  303,  302,   59,
  123,  123,   59,  308,   41,  308,  308,  308,  308,  304,
   44,   59,  123,  123,  291,   59,  308,  302,  292,  302,
  309,   59,  302,  309,  302,   58,  285,   58,  303,  302,
  124,  303,   58,  293,  302,  293,  293,   59,  309,   59,
   59,   59,   83,   -1,   -1,  154,   -1,   -1,  126,  127,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  256,  256,   -1,  256,  256,   -1,  256,   -1,   -1,
   -1,   -1,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,   -1,  280,  256,
  282,  283,  259,  260,   -1,   -1,  288,  289,  287,   -1,
  295,  296,  297,  294,   -1,   -1,  299,  300,   -1,   -1,
   -1,   -1,   -1,   -1,  309,  309,   -1,  284,  309,  286,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  309,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 310
#define YYUNDFTOKEN 340
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'('","')'",0,0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,"':'","';'",0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'","'|'","'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error",
"OPTIONS","KEYS","PIXMAPS","DECOR","STYLE","PLUGDAT","FORPLUG","OPAQUEMOVE",
"MOUSEMOD","ANIMDELAY","DESKTOPCNT","DESKTOPWID","DESKTOPHEI","FULLSCRZOOM",
"LINEWIDTH","LINEFG","WANTMITSHM","WSPACESLIDE","RELRESIZE","FOCUSNEW",
"XINCORRECT","FOCUS","FOCUSTYPE","PLACEMENT","PLACETYPE","PLACENONZEROS",
"PLACETRANS","TITLEFONT","TITLE","TITLECOLOR","KEYNAME","PLACEINTERACT",
"INTERACTTIME","DBUTTONLINES","DECTYPE","DECEDGE","ACTION","GROUPS","DEFAULT",
"TRANSIENT","INTERNAL","LOAD","PARAM","FPARAM","PLUGPARAM","INTEGER","BOOLVAL",
"MODIFIER","NOMASK","CYCLETYPE","MVDIR","STRING","IDENT","FLOAT","$accept",
"rcfile","modmask","modmaskifiers","keyarg","decarg","pixmapid","groupid",
"filename","floatval","subparams","options_stmts","keys_stmts","style_stmts",
"$$1","$$2","options_stmt","keys_stmt","style_stmt","pixmaps_stmts",
"decor_stmts","pixmaps_stmt","groups_stmts","decor_stmt","groups_stmt","params",
"$$3","addgroup","decorlist","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : rcfile",
"rcfile :",
"rcfile : rcfile error",
"rcfile : rcfile OPTIONS '{' options_stmts '}'",
"rcfile : rcfile KEYS '{' keys_stmts '}'",
"rcfile : rcfile STYLE '{' style_stmts '}'",
"rcfile : rcfile FORPLUG STRING filename ';'",
"$$1 :",
"rcfile : rcfile LOAD $$1 STRING subparams",
"$$2 :",
"rcfile : rcfile PLUGDAT $$2 subparams",
"options_stmts :",
"options_stmts : options_stmts options_stmt ';'",
"keys_stmts :",
"keys_stmts : keys_stmts keys_stmt ';'",
"style_stmts :",
"style_stmts : style_stmts style_stmt ';'",
"style_stmts : style_stmts PIXMAPS '{' pixmaps_stmts '}'",
"style_stmts : style_stmts DECOR '{' decor_stmts '}'",
"pixmaps_stmts :",
"pixmaps_stmts : pixmaps_stmts pixmaps_stmt ';'",
"decor_stmts :",
"decor_stmts : decor_stmts GROUPS '{' groups_stmts '}'",
"decor_stmts : decor_stmts decor_stmt ';'",
"groups_stmts :",
"groups_stmts : groups_stmts groups_stmt ';'",
"subparams : ';'",
"$$3 :",
"subparams : '{' $$3 params '}'",
"params :",
"params : params FPARAM STRING filename subparams",
"params : params PARAM STRING STRING subparams",
"options_stmt : error",
"options_stmt : DESKTOPCNT INTEGER",
"options_stmt : DESKTOPWID INTEGER",
"options_stmt : DESKTOPHEI INTEGER",
"options_stmt : FOCUS FOCUSTYPE",
"options_stmt : FULLSCRZOOM BOOLVAL",
"options_stmt : OPAQUEMOVE BOOLVAL",
"options_stmt : FOCUSNEW BOOLVAL",
"options_stmt : MOUSEMOD modmask",
"options_stmt : ANIMDELAY INTEGER",
"options_stmt : PLACETRANS BOOLVAL",
"options_stmt : PLACENONZEROS BOOLVAL",
"options_stmt : PLACEINTERACT BOOLVAL",
"options_stmt : INTERACTTIME INTEGER",
"options_stmt : PLACEMENT PLACETYPE",
"options_stmt : LINEWIDTH INTEGER",
"options_stmt : LINEFG STRING",
"options_stmt : WANTMITSHM BOOLVAL",
"options_stmt : WSPACESLIDE BOOLVAL",
"options_stmt : RELRESIZE BOOLVAL",
"options_stmt : XINCORRECT BOOLVAL",
"keys_stmt : error",
"keys_stmt : KEYNAME STRING modmask keyarg",
"style_stmt : error",
"style_stmt : TITLEFONT STRING",
"style_stmt : TITLECOLOR STRING",
"pixmaps_stmt : error",
"pixmaps_stmt : IDENT filename",
"groups_stmt : error",
"groups_stmt : addgroup decorlist",
"groups_stmt : DEFAULT groupid",
"groups_stmt : TRANSIENT groupid",
"groups_stmt : INTERNAL groupid",
"decor_stmt : error",
"decor_stmt : IDENT DECTYPE DECEDGE INTEGER INTEGER INTEGER floatval floatval BOOLVAL BOOLVAL ACTION ACTION ACTION pixmapid pixmapid decarg",
"filename : STRING",
"floatval : INTEGER",
"floatval : FLOAT",
"modmask : '(' modmaskifiers ')'",
"modmask : '(' NOMASK ')'",
"modmaskifiers : MODIFIER",
"modmaskifiers : modmaskifiers '|' MODIFIER",
"keyarg :",
"keyarg : STRING",
"keyarg : INTEGER",
"keyarg : MVDIR",
"keyarg : CYCLETYPE",
"keyarg : INTEGER ',' INTEGER",
"decarg :",
"decarg : pixmapid",
"addgroup : IDENT",
"decorlist :",
"decorlist : decorlist IDENT",
"decorlist : decorlist IDENT ':' TITLE ':' INTEGER ':' INTEGER",
"groupid : IDENT",
"pixmapid : IDENT",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 509 "rcfile.y"

/* exported parsing function */
void rcfile_parse() {
	forplug_t *fp_tab, *next;
	char rcfn[MAXPATHLEN];
	FILE *fp;

	/*
	 * get space for filename/dir strings, and for the subparams
	 * stack.  the subparams stack is used for parsing of plugin
	 * subparams in the yacc grammar.
	 */
	filedir = malloc(MAXPATHLEN);
	if (!filedir)
		return;
	filename = malloc(MAXPATHLEN);
	if (!filename)
		goto free1;
	subparams_stack_size = SUBP_STACK_GRAN;
	subparams_stack = calloc(subparams_stack_size, sizeof(subparams_t *));
	if (!subparams_stack)
		goto free2;

	/* build file location strings */	
	snprintf(filedir, MAXPATHLEN, "%s/.golem/", homedir_path);
	snprintf(filename, MAXPATHLEN, "%s", "golemrc");
	snprintf(rcfn, sizeof(rcfn), "%s%s", filedir, filename);

	/*
	 * attempt to open the user's golemrc, if not, try for
	 * the system-wide rc file.
	 */
	fp = fopen(rcfn, "r");
	if (!fp) {
		snprintf(filedir, MAXPATHLEN, "%s/", PKG_SYSCONFDIR);
		snprintf(rcfn, sizeof(rcfn), "%s%s", filedir, filename);
		fp = fopen(rcfn, "r");
		if (!fp)
			goto free3;
		warnx("unable to read from ~/.golem/golemrc, using system-wide file");
	}

	/*
	 * parse the file, when the flexer reaches EOF for the
	 * file, it will call fclose() on it, so it is not
	 * necessary to call that here.
	 */
	yyin = fp;
	yyparse();

	/* free the forplug table */
	fp_tab = SLIST_FIRST(&forplug_tab);
	while (fp_tab) {
		next = SLIST_NEXT(fp_tab, fp_list);
		free(fp_tab->incfile);
		free(fp_tab->plugin);
		free(fp_tab);
		fp_tab = next;
	}
	SLIST_INIT(&forplug_tab);

free3:	
	free(subparams_stack);
	subparams_stack = NULL;
free2:	
	free(filename);
	filename = NULL;
free1:	
	free(filedir);
	filedir = NULL;
}
#line 803 "y.tab.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 6:
#line 172 "rcfile.y"
	{
				if (rcfile_forplug(yystack.l_mark[-2].str, yystack.l_mark[-1].str) == NULL) {
					free(yystack.l_mark[-2].str);
					free(yystack.l_mark[-1].str);
					yyerror("out of memory: couldn't make forplug entry");
					YYERROR;
				}
			}
#line 1 ""
break;
case 7:
#line 180 "rcfile.y"
	{
				if (inside_forplug) {
					yyerror("plugins may not be loaded "
						"from a forplug include");
					YYERROR;
				}
			}
#line 1 ""
break;
case 8:
#line 187 "rcfile.y"
	{
				plugin_t *plugin;
				forplug_t *forplug;
				
				forplug = rcfile_find_forplug(yystack.l_mark[-1].str);

				if ((plugin = plugin_load(yystack.l_mark[-1].str, yystack.l_mark[0].subparams, forplug ? 0 : 1)) == NULL) {
					if (yystack.l_mark[0].subparams)
						free(yystack.l_mark[0].subparams);
					yyerror("unable to load plugin");
					YYERROR;
				}

				if (forplug)
					rclex_include(forplug->incfile, plugin);
				if (yystack.l_mark[0].subparams)
					free(yystack.l_mark[0].subparams);
			}
#line 1 ""
break;
case 9:
#line 205 "rcfile.y"
	{
				if (!inside_forplug) {
					yyerror("plugdat section only valid "
						"in a forplug include");
					YYERROR;
				}
			}
#line 1 ""
break;
case 10:
#line 212 "rcfile.y"
	{
		  		plugin_subparams_merge(&inside_forplug->params, yystack.l_mark[0].subparams);
		  		if (yystack.l_mark[0].subparams)
		  			free(yystack.l_mark[0].subparams);
		  	}
#line 1 ""
break;
case 26:
#line 246 "rcfile.y"
	{ yyval.subparams = NULL; }
#line 1 ""
break;
case 27:
#line 247 "rcfile.y"
	{
				if (++subparams_stack_loc > subparams_stack_size) {
					subparams_t **tmp;

					subparams_stack_size += SUBP_STACK_GRAN;
					tmp = realloc(subparams_stack,
						subparams_stack_size * sizeof(subparams_t *));
					if (!tmp) {
						yyerror("not enough memory while"
							" parsing plugin parameters");
						YYERROR;
					}
					subparams_stack = tmp;
					
				}
				subparams_stack[subparams_stack_loc - 1] =
					calloc(1, sizeof(subparams_t));
			}
#line 1 ""
break;
case 28:
#line 265 "rcfile.y"
	{
				yyval.subparams = subparams_stack[subparams_stack_loc - 1]; 
				subparams_stack[--subparams_stack_loc] = NULL;
			}
#line 1 ""
break;
case 30:
#line 272 "rcfile.y"
	{
				if (rcfile_addparam(yystack.l_mark[-2].str, yystack.l_mark[-1].str, yystack.l_mark[0].subparams) == -1)
					YYERROR;
			}
#line 1 ""
break;
case 31:
#line 276 "rcfile.y"
	{
				if (rcfile_addparam(yystack.l_mark[-2].str, yystack.l_mark[-1].str, yystack.l_mark[0].subparams) == -1)
					YYERROR;
			}
#line 1 ""
break;
case 33:
#line 283 "rcfile.y"
	{ if (yystack.l_mark[0].num > 0) options.desktop_count = yystack.l_mark[0].num; }
#line 1 ""
break;
case 34:
#line 284 "rcfile.y"
	{ if (yystack.l_mark[0].num > 0) options.desktop_width = yystack.l_mark[0].num; }
#line 1 ""
break;
case 35:
#line 285 "rcfile.y"
	{ if (yystack.l_mark[0].num > 0) options.desktop_height = yystack.l_mark[0].num; }
#line 1 ""
break;
case 36:
#line 286 "rcfile.y"
	{ options.focus = yystack.l_mark[0].num; }
#line 1 ""
break;
case 37:
#line 287 "rcfile.y"
	{ options.fullscreen_zoom = yystack.l_mark[0].num; }
#line 1 ""
break;
case 38:
#line 288 "rcfile.y"
	{ options.opaquemove = yystack.l_mark[0].num; }
#line 1 ""
break;
case 39:
#line 289 "rcfile.y"
	{ options.focus_new = yystack.l_mark[0].num; }
#line 1 ""
break;
case 40:
#line 290 "rcfile.y"
	{ options.mouse_modifier = yystack.l_mark[0].num; }
#line 1 ""
break;
case 41:
#line 291 "rcfile.y"
	{ options.anim_delay = yystack.l_mark[0].num; }
#line 1 ""
break;
case 42:
#line 292 "rcfile.y"
	{ options.place_transients = yystack.l_mark[0].num; }
#line 1 ""
break;
case 43:
#line 293 "rcfile.y"
	{ options.place_nonzeros = yystack.l_mark[0].num; }
#line 1 ""
break;
case 44:
#line 294 "rcfile.y"
	{ options.place_interactive = yystack.l_mark[0].num; }
#line 1 ""
break;
case 45:
#line 295 "rcfile.y"
	{ options.interact_timeout = yystack.l_mark[0].num; }
#line 1 ""
break;
case 46:
#line 296 "rcfile.y"
	{ options.placement = yystack.l_mark[0].num; }
#line 1 ""
break;
case 47:
#line 297 "rcfile.y"
	{ if (yystack.l_mark[0].num > 0) options.linewidth = yystack.l_mark[0].num; }
#line 1 ""
break;
case 48:
#line 298 "rcfile.y"
	{ SETSTR(options.linefgclr, yystack.l_mark[0].str); }
#line 1 ""
break;
case 49:
#line 299 "rcfile.y"
	{ options.wantmitshm = yystack.l_mark[0].num; }
#line 1 ""
break;
case 50:
#line 300 "rcfile.y"
	{ options.workspace_slide = yystack.l_mark[0].num; }
#line 1 ""
break;
case 51:
#line 301 "rcfile.y"
	{ options.relative_resize = yystack.l_mark[0].num; }
#line 1 ""
break;
case 52:
#line 302 "rcfile.y"
	{ options.xinerama_correctloc = yystack.l_mark[0].num; }
#line 1 ""
break;
case 54:
#line 306 "rcfile.y"
	{
				int keycode;
				keycode = XKeysymToKeycode(display, XStringToKeysym(yystack.l_mark[-2].str));
				if (keycode == 0 && strncmp(yystack.l_mark[-2].str, "KeyCode", 7) == 0)
					keycode = atoi(yystack.l_mark[-2].str + 7);
				if (keycode > 0)
					if (keys_add(keycode, yystack.l_mark[-1].num, yystack.l_mark[-3].num, (void *) yystack.l_mark[0].vptr) == NULL) {
						free(yystack.l_mark[-2].str);
						yyerror("couldn't allocate memory for keybind_t");
						YYERROR;
					}
				free(yystack.l_mark[-2].str);
			}
#line 1 ""
break;
case 56:
#line 322 "rcfile.y"
	{ SETSTR(options.title_font, yystack.l_mark[0].str); }
#line 1 ""
break;
case 57:
#line 323 "rcfile.y"
	{ SETSTR(options.titleclr, yystack.l_mark[0].str); }
#line 1 ""
break;
case 59:
#line 327 "rcfile.y"
	{
				if (pixmap_ident(yystack.l_mark[-1].str) != NULL) {
					free(yystack.l_mark[-1].str);
					free(yystack.l_mark[0].str);
					yyerror("duplicate pixmap identifier");
					YYERROR;
				}

				if (pixmap_add(yystack.l_mark[-1].str, yystack.l_mark[0].str) == NULL) {
					free(yystack.l_mark[-1].str);
					free(yystack.l_mark[0].str);
					yyerror("couldn't allocate memory for pixmap");
					YYERROR;
				}
			}
#line 1 ""
break;
case 61:
#line 345 "rcfile.y"
	{ dgroup_current = NULL; }
#line 1 ""
break;
case 62:
#line 346 "rcfile.y"
	{ options.dgroup_default = yystack.l_mark[0].vptr; }
#line 1 ""
break;
case 63:
#line 347 "rcfile.y"
	{ options.dgroup_trans = yystack.l_mark[0].vptr; }
#line 1 ""
break;
case 64:
#line 348 "rcfile.y"
	{ options.dgroup_internal = yystack.l_mark[0].vptr; }
#line 1 ""
break;
case 66:
#line 354 "rcfile.y"
	{
				decor_t *decor;

				if (decor_ident(yystack.l_mark[-15].str) != NULL) {
					free(yystack.l_mark[-15].str);
					yyerror("duplicate decoration identifier\n");
					YYERROR;
				}

				decor = calloc(1, sizeof(decor_t));
				if (!decor) {
					free(yystack.l_mark[-15].str);
					yyerror("couldn't allocate memory for decoration.");
					YYERROR;
				}
				decor->ident = yystack.l_mark[-15].str;
				decor->type = yystack.l_mark[-14].num;
				decor->edge = yystack.l_mark[-13].num;
				decor->offset = yystack.l_mark[-12].num;
				decor->lenmod = yystack.l_mark[-11].num;
				decor->soffset = yystack.l_mark[-10].num;
				decor->offsetmult = yystack.l_mark[-9].flnum;
				decor->lenmult = yystack.l_mark[-8].flnum;
				decor->flags.shaped = yystack.l_mark[-7].num;
				decor->flags.button = yystack.l_mark[-6].num;
				decor->lclick_action = yystack.l_mark[-5].num;
				decor->mclick_action = yystack.l_mark[-4].num;
				decor->rclick_action = yystack.l_mark[-3].num;
				decor->pixmap = yystack.l_mark[-2].vptr;
				decor->focpixmap = yystack.l_mark[-1].vptr;
				decor->pressedmap = yystack.l_mark[0].vptr;
				decor_add(decor);
			}
#line 1 ""
break;
case 67:
#line 389 "rcfile.y"
	{
				char *tmp = rcfile_filename(yystack.l_mark[0].str);

				free(yystack.l_mark[0].str);
				if (!tmp) {
					yyerror("couldn't get memory for filename");
					YYERROR;
				}

				yyval.str = tmp;
			}
#line 1 ""
break;
case 68:
#line 402 "rcfile.y"
	{ yyval.flnum = (double) yystack.l_mark[0].num; }
#line 1 ""
break;
case 70:
#line 406 "rcfile.y"
	{ yyval.num = yystack.l_mark[-1].num; }
#line 1 ""
break;
case 71:
#line 407 "rcfile.y"
	{ yyval.num = 0; }
#line 1 ""
break;
case 73:
#line 411 "rcfile.y"
	{ yyval.num |= yystack.l_mark[0].num; }
#line 1 ""
break;
case 74:
#line 414 "rcfile.y"
	{ yyval.vptr = (void *) 0; }
#line 1 ""
break;
case 75:
#line 415 "rcfile.y"
	{ yyval.vptr = (void *) yystack.l_mark[0].str; }
#line 1 ""
break;
case 76:
#line 416 "rcfile.y"
	{ yyval.vptr = (void *) yystack.l_mark[0].num; }
#line 1 ""
break;
case 77:
#line 417 "rcfile.y"
	{ yyval.vptr = (void *) yystack.l_mark[0].num; }
#line 1 ""
break;
case 78:
#line 418 "rcfile.y"
	{ yyval.vptr = (void *) yystack.l_mark[0].num; }
#line 1 ""
break;
case 79:
#line 419 "rcfile.y"
	{
				point_t *pt;

				pt = malloc(sizeof(point_t));
				if (!pt) {
					yyerror("couldn't get memory for keyarg, point_t");
					YYERROR;
				}

				pt->x = yystack.l_mark[-2].num;
				pt->y = yystack.l_mark[0].num;
				yyval.vptr = (void *) pt;
			}
#line 1 ""
break;
case 80:
#line 434 "rcfile.y"
	{ yyval.vptr = NULL; }
#line 1 ""
break;
case 82:
#line 438 "rcfile.y"
	{
				if (dgroup_ident(yystack.l_mark[0].str) != NULL) {
					free(yystack.l_mark[0].str);
					yyerror("duplicate decoration group identifier");
					YYERROR;
				}

				if ((dgroup_current = dgroup_add(yystack.l_mark[0].str)) == NULL) {
					free(yystack.l_mark[0].str);
					yyerror("couldn't allocate memory for decoration group");
					YYERROR;
				}
			}
#line 1 ""
break;
case 84:
#line 454 "rcfile.y"
	{
				decor_t *decor;

				decor = decor_ident(yystack.l_mark[0].str);
				free(yystack.l_mark[0].str);
				if (decor == NULL) {
					yyerror("undeclared decoration group identifier");
					YYERROR;
				}
				if (dgroup_add_decor(dgroup_current, decor) == -1)
					warnx("out of mem trying to add decor to dgroup");
			}
#line 1 ""
break;
case 85:
#line 466 "rcfile.y"
	{
				decor_t *decor;

				decor = decor_ident(yystack.l_mark[-6].str);
				free(yystack.l_mark[-6].str);
				if (decor == NULL) {
					yyerror("undeclared decoration group identifier");
					YYERROR;
				}
				if (dgroup_add_decor(dgroup_current, decor) == -1)
					warnx("out of mem trying to add decor to dgroup");

				/* now add to the title for the group */
				dgroup_current->title = decor;
				dgroup_current->title_x = yystack.l_mark[-2].num;
				dgroup_current->title_y = yystack.l_mark[0].num;
			}
#line 1 ""
break;
case 86:
#line 485 "rcfile.y"
	{
				dgroup_t *dgroup = dgroup_ident(yystack.l_mark[0].str);
				free(yystack.l_mark[0].str);
				if (dgroup == NULL) {
					yyerror("undeclared decoration group identifier");
					YYERROR;
				}
				yyval.vptr = dgroup;
			}
#line 1 ""
break;
case 87:
#line 496 "rcfile.y"
	{
				pixmap_t *pixmap = pixmap_ident(yystack.l_mark[0].str);
				free(yystack.l_mark[0].str);
				if (pixmap == NULL) {
					yyerror("undeclared pixmap identifier");
					YYERROR;
				}
				yyval.vptr = pixmap;
			}
#line 1 ""
break;
#line 1954 "y.tab.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
